/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.world;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.bausystem.config.BauServer;
import de.steamwar.bausystem.region.Region;
import de.steamwar.bausystem.utils.ScoreboardElement;
import de.steamwar.linkage.Linked;
import de.steamwar.sql.UserConfig;
import org.bukkit.entity.Player;

@Linked
public class BauLockStateScoreboard implements ScoreboardElement {

    private static final String BAU_LOCK_CONFIG_NAME = "baulockstate";

    @Override
    public ScoreboardGroup getGroup() {
        return ScoreboardGroup.FOOTER;
    }

    @Override
    public int order() {
        return -10;
    }

    @Override
    public String get(Region region, Player p) {
        if (!BauServer.getInstance().getOwner().equals(p.getUniqueId())) {
            return null;
        }
        String state = UserConfig.getConfig(p.getUniqueId(), BAU_LOCK_CONFIG_NAME);
        switch (state == null ? BauLockState.OPEN : BauLockState.valueOf(state)) {
            case OPEN:
                return null;
            default:
                return "§e" + BauSystem.MESSAGE.parse("SCOREBOARD_LOCK_" + state.toUpperCase(), p);
        }
    }

    public enum BauLockState {

        NOBODY,
        SUPERVISOR,
        SERVERTEAM,
        TEAM_AND_SERVERTEAM,
        TEAM,
        OPEN
    }

}
